#!/usr/bin/env node
module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 27);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("path");

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = __webpack_require__(0);

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  context: _path2.default.resolve(process.cwd(), './src'),
  distOutput: '/public',
  jsPath: 'js',
  cssPath: 'css',
  publicPath: '/assets/',
  indexFile: 'index.html',
  staticAssetsPath: '/public/assets',
  localIdentName: '[name]__[local]--[hash:base64:5]',
  autoPrefixer: ['last 2 versions'],
  devCssBundle: 'styles.bundle.css',
  prodCssBundle: 'styles.[contenthash:8].bundle.css',
  diagnostics: {
    heartbeat: '/diagnostic/heartbeat',
    version: '/diagnostic/version'
  },
  isDevEnvironment: process.env.NODE_ENV !== 'production'
};

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("webpack");

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = require("yargs");

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = require("extract-text-webpack-plugin");

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMessage = undefined;

var _yargs = __webpack_require__(3);

var _argv$debug = _yargs.argv.debug,
    debug = _argv$debug === undefined ? false : _argv$debug;


var messages = {
  welcome: function welcome(_ref) {
    var appName = _ref.appName,
        isDevEnvironment = _ref.isDevEnvironment,
        port = _ref.port;
    return '                  \n    RCA-Precursor: Starting ' + appName + '\n    http://localhost:' + (port || 3000) + '\n    Environment: ' + (isDevEnvironment ? 'Development' : 'Production') + '\n    Debug: ' + debug + '\n  ';
  },
  error: function error(_ref2) {
    var type = _ref2.type,
        _error = _ref2.error;

    var types = {
      static: 'StaticMiddleware:\n\n' + _error
    };
    return types[type];
  }
};

var getMessage = exports.getMessage = function getMessage(type, args) {
  return messages[type] ? messages[type](args) : messages.error;
};

exports.default = function (err) {
  return console.log(err);
};

/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = require("babel-polyfill");

/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = require("babel-register");

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _cssModulesRequireHook = __webpack_require__(9);

var _cssModulesRequireHook2 = _interopRequireDefault(_cssModulesRequireHook);

var _defaultConfig = __webpack_require__(1);

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _cssModulesRequireHook2.default)({
  generateScopedName: _defaultConfig2.default.localIdentName
});

/***/ }),
/* 9 */
/***/ (function(module, exports) {

module.exports = require("css-modules-require-hook");

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
//  Nasty.
//  eslint-disable-next-line
var evalImport = function evalImport(p) {
  return eval('require(\'' + p + '\');');
};

exports.default = function (filename) {
  return new Promise(function (resolve, reject) {
    var configFile = filename;
    if (!configFile.includes('.js')) {
      configFile += '.js';
    }
    try {
      resolve(evalImport(configFile).default);
    } catch (err) {
      reject(err);
    }
  });
};

/***/ }),
/* 11 */
/***/ (function(module, exports) {

module.exports = require("fs");

/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _path = __webpack_require__(0);

var _path2 = _interopRequireDefault(_path);

var _loaders = __webpack_require__(13);

var _loaders2 = _interopRequireDefault(_loaders);

var _plugins = __webpack_require__(16);

var _plugins2 = _interopRequireDefault(_plugins);

var _defaultConfig = __webpack_require__(1);

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (config) {
  var _config$context = config.context,
      context = _config$context === undefined ? _path2.default.resolve(process.cwd(), './src') : _config$context,
      entry = config.entry,
      _config$distOutput = config.distOutput,
      distOutput = _config$distOutput === undefined ? _defaultConfig2.default.distOutput : _config$distOutput,
      _config$publicPath = config.publicPath,
      publicPath = _config$publicPath === undefined ? _defaultConfig2.default.publicPath : _config$publicPath,
      _config$jsPath = config.jsPath,
      jsPath = _config$jsPath === undefined ? _defaultConfig2.default.jsPath : _config$jsPath,
      isDevEnvironment = config.isDevEnvironment;


  if (!entry) {
    throw new Error('No entry files are specified');
  }

  return _extends({
    context: context,

    entry: _extends({}, entry, isDevEnvironment && {
      hotReload: 'webpack-hot-middleware/client?reload=true'
    }),

    output: {
      filename: isDevEnvironment ? jsPath + '/[name].bundle.js' : jsPath + '/[name].[chunkhash:8].bundle.js',
      chunkFilename: isDevEnvironment ? jsPath + '/[name].chunk.js' : jsPath + '/[name].[chunkhash:8].chunk.js',
      path: _path2.default.join(process.cwd(), distOutput, publicPath),
      publicPath: publicPath
    }

  }, isDevEnvironment && {
    devServer: {
      contentBase: publicPath,
      hot: true,
      inline: true,
      historyApiFallback: true
    } && {
      devtool: 'cheap-module-source-map'
    }
  }, {

    module: {
      rules: (0, _loaders2.default)(config)
    },
    plugins: (0, _plugins2.default)(config)
  });
};

/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extractTextWebpackPlugin = __webpack_require__(4);

var _extractTextWebpackPlugin2 = _interopRequireDefault(_extractTextWebpackPlugin);

var _defaultConfig = __webpack_require__(1);

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

var _webpack = __webpack_require__(2);

var _webpack2 = _interopRequireDefault(_webpack);

var _postcssImport = __webpack_require__(14);

var _postcssImport2 = _interopRequireDefault(_postcssImport);

var _postcssCssnext = __webpack_require__(15);

var _postcssCssnext2 = _interopRequireDefault(_postcssCssnext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var _ref$localIdentName = _ref.localIdentName,
      localIdentName = _ref$localIdentName === undefined ? _defaultConfig2.default.localIdentName : _ref$localIdentName;
  return [{
    test: /\.js?$/,
    exclude: /node_modules/,
    loader: 'babel-loader',
    options: {
      babelrc: false,
      presets: ['es2015', 'react', 'stage-0'],
      plugins: ['transform-regenerator']
    }
  }, {
    test: /\.(css|scss)?$/,
    exclude: /node_modules/,
    loader: _extractTextWebpackPlugin2.default.extract([{
      loader: 'css-loader',
      options: {
        context: './',
        modules: true,
        importLoaders: 1,
        localIdentName: localIdentName
      }
    }, {
      loader: 'postcss-loader',
      options: {
        plugins: [(0, _postcssImport2.default)({
          addDependencyTo: _webpack2.default
        }), (0, _postcssCssnext2.default)()]
      }
    }])
  }, {
    test: /\.(png|svg)?$/,
    exclude: /node_modules/,
    use: {
      loader: 'file-loader',
      options: {
        name: '[name].[hash].[ext]',
        outputPath: '/images'
      }
    }
  }];
};

/***/ }),
/* 14 */
/***/ (function(module, exports) {

module.exports = require("postcss-import");

/***/ }),
/* 15 */
/***/ (function(module, exports) {

module.exports = require("postcss-cssnext");

/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _webpack = __webpack_require__(2);

var _webpack2 = _interopRequireDefault(_webpack);

var _path = __webpack_require__(0);

var _path2 = _interopRequireDefault(_path);

var _htmlWebpackPlugin = __webpack_require__(17);

var _htmlWebpackPlugin2 = _interopRequireDefault(_htmlWebpackPlugin);

var _extractTextWebpackPlugin = __webpack_require__(4);

var _extractTextWebpackPlugin2 = _interopRequireDefault(_extractTextWebpackPlugin);

var _chunkManifestWebpackPlugin = __webpack_require__(18);

var _chunkManifestWebpackPlugin2 = _interopRequireDefault(_chunkManifestWebpackPlugin);

var _webpackChunkHash = __webpack_require__(19);

var _webpackChunkHash2 = _interopRequireDefault(_webpackChunkHash);

var _uglifyjsWebpackPlugin = __webpack_require__(20);

var _uglifyjsWebpackPlugin2 = _interopRequireDefault(_uglifyjsWebpackPlugin);

var _bundling = __webpack_require__(21);

var _defaultConfig = __webpack_require__(1);

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var isVendor = function isVendor(_ref) {
  var resource = _ref.resource;
  return resource && resource.indexOf('node_modules') >= 0 && resource.match(/\.js$/);
};

exports.default = function (_ref2) {
  var _ref2$context = _ref2.context,
      context = _ref2$context === undefined ? _defaultConfig2.default.context : _ref2$context,
      _ref2$distOutput = _ref2.distOutput,
      distOutput = _ref2$distOutput === undefined ? _defaultConfig2.default.distOutput : _ref2$distOutput,
      _ref2$jsPath = _ref2.jsPath,
      jsPath = _ref2$jsPath === undefined ? _defaultConfig2.default.jsPath : _ref2$jsPath,
      _ref2$cssPath = _ref2.cssPath,
      cssPath = _ref2$cssPath === undefined ? _defaultConfig2.default.cssPath : _ref2$cssPath,
      _ref2$devCssBundle = _ref2.devCssBundle,
      devCssBundle = _ref2$devCssBundle === undefined ? _defaultConfig2.default.devCssBundle : _ref2$devCssBundle,
      _ref2$prodCssBundle = _ref2.prodCssBundle,
      prodCssBundle = _ref2$prodCssBundle === undefined ? _defaultConfig2.default.prodCssBundle : _ref2$prodCssBundle,
      isDevEnvironment = _ref2.isDevEnvironment,
      _ref2$plugins = _ref2.plugins,
      plugins = _ref2$plugins === undefined ? [] : _ref2$plugins,
      routes = _ref2.routes;

  //  Gets all { bundle } values from the routeConfig
  var bundleNames = (0, _bundling.getBundlesByName)(routes);

  //  Environment plugins define how webpack should
  //  be bundled for both production and development.
  //  Things like hot-module-reloading aren't required for
  //  prod, as an example.
  var environmentPlugins = !isDevEnvironment ? [new _webpack2.default.HashedModuleIdsPlugin(), new _webpackChunkHash2.default(), new _chunkManifestWebpackPlugin2.default({
    filename: jsPath + '/chunk-manifest.js',
    manifestVariable: 'webpackManifest',
    inlineManifest: true
  }), new _uglifyjsWebpackPlugin2.default()] : [new _webpack2.default.HotModuleReplacementPlugin()];

  return [].concat(_toConsumableArray(plugins), environmentPlugins, [

  //  Webpack bundle injection
  //  An array of chunks to be excluded from
  //  the HtmlWebpackPlugin injection.  This is important
  //  because routes that require lazy loading will be
  //  injected into the <head> when they are needed
  new _htmlWebpackPlugin2.default({
    inject: true,
    template: context + '/index.html',
    filename: _path2.default.join(process.cwd(), '.', distOutput, 'index.html'),
    excludeChunks: bundleNames
  }),

  //  Chunk common vendor / main files
  new _webpack2.default.optimize.CommonsChunkPlugin({
    name: ['vendor', 'manifest'],
    minChunks: isVendor
  })], _toConsumableArray(bundleNames.length && bundleNames.map(function (name) {
    return new _webpack2.default.optimize.CommonsChunkPlugin({
      name: name,
      chunks: [name],
      minChunks: 1
    });
  })), [new _extractTextWebpackPlugin2.default({
    filename: isDevEnvironment ? devCssBundle : cssPath + '/' + prodCssBundle,
    allChunks: true
  }),

  //  Output bundles will run in
  //  either production or development
  new _webpack2.default.DefinePlugin({
    'process.env': {
      NODE_ENV: JSON.stringify(isDevEnvironment ? 'development' : 'production'),
      API_URL: JSON.stringify('http://10.10.10.10:8080/bands')
    }
  })]);
};

/***/ }),
/* 17 */
/***/ (function(module, exports) {

module.exports = require("html-webpack-plugin");

/***/ }),
/* 18 */
/***/ (function(module, exports) {

module.exports = require("chunk-manifest-webpack-plugin");

/***/ }),
/* 19 */
/***/ (function(module, exports) {

module.exports = require("webpack-chunk-hash");

/***/ }),
/* 20 */
/***/ (function(module, exports) {

module.exports = require("uglifyjs-webpack-plugin");

/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getBundlesByName = exports.getBundleEntriesFromRoutes = undefined;

var _getBundleEntriesFromRoutes2 = __webpack_require__(22);

var _getBundleEntriesFromRoutes3 = _interopRequireDefault(_getBundleEntriesFromRoutes2);

var _getBundlesByName2 = __webpack_require__(23);

var _getBundlesByName3 = _interopRequireDefault(_getBundlesByName2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.getBundleEntriesFromRoutes = _getBundleEntriesFromRoutes3.default;
exports.getBundlesByName = _getBundlesByName3.default;

/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (routes) {
  return routes.filter(function (route) {
    return typeof route.bundle !== 'undefined';
  }).reduce(function (acc, route) {
    acc[route.bundle.name.toLowerCase()] = route.bundle.location;
    return acc;
  }, {});
};

/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (routes) {
  return routes.filter(function (route) {
    return typeof route.bundle !== 'undefined';
  }).map(function (route) {
    return route.bundle.name;
  });
};

/***/ }),
/* 24 */,
/* 25 */,
/* 26 */,
/* 27 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

__webpack_require__(6);

__webpack_require__(7);

var _yargs = __webpack_require__(3);

var _path = __webpack_require__(0);

var _path2 = _interopRequireDefault(_path);

var _hooks = __webpack_require__(8);

var _hooks2 = _interopRequireDefault(_hooks);

var _defaultConfig = __webpack_require__(1);

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

var _requireFile = __webpack_require__(10);

var _requireFile2 = _interopRequireDefault(_requireFile);

var _createOutputFolder = __webpack_require__(28);

var _createOutputFolder2 = _interopRequireDefault(_createOutputFolder);

var _generateWebpackOutput = __webpack_require__(30);

var _generateWebpackOutput2 = _interopRequireDefault(_generateWebpackOutput);

var _mapStatsToOutput = __webpack_require__(31);

var _mapStatsToOutput2 = _interopRequireDefault(_mapStatsToOutput);

var _messaging = __webpack_require__(5);

var _messaging2 = _interopRequireDefault(_messaging);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

//  Ensure CSS-Modules won't break things
(0, _hooks2.default)();

_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
  var defaultConfigPath, _argv$config, config, userConfig, fullWebpackConfig;

  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          //  TODO - get this from context
          defaultConfigPath = './src/config';
          _argv$config = _yargs.argv.config, config = _argv$config === undefined ? defaultConfigPath : _argv$config;
          _context.next = 4;
          return (0, _requireFile2.default)(_path2.default.join(process.cwd(), config));

        case 4:
          userConfig = _context.sent;
          fullWebpackConfig = _extends({}, _defaultConfig2.default, userConfig);


          (0, _createOutputFolder2.default)(fullWebpackConfig).then((0, _generateWebpackOutput2.default)(fullWebpackConfig)).then(_mapStatsToOutput2.default).catch(_messaging2.default);

        case 7:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, undefined);
}))();

/***/ }),
/* 28 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = __webpack_require__(0);

var _path2 = _interopRequireDefault(_path);

var _fs = __webpack_require__(11);

var _fs2 = _interopRequireDefault(_fs);

var _rimraf = __webpack_require__(29);

var _rimraf2 = _interopRequireDefault(_rimraf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var handleError = function handleError(err) {
  throw new Error(err);
};

var createOutputFolder = function createOutputFolder() {
  var outputPath = _path2.default.resolve(process.cwd(), './public');

  return new Promise(function (resolve) {
    if (!_fs2.default.existsSync(outputPath)) {
      _fs2.default.mkdir(outputPath, function (err) {
        if (err) handleError(err);
        resolve();
      });
    } else {
      (0, _rimraf2.default)(outputPath, function (err) {
        if (err) handleError(err);
        resolve(createOutputFolder(outputPath));
      });
    }
  });
};

exports.default = createOutputFolder;

/***/ }),
/* 29 */
/***/ (function(module, exports) {

module.exports = require("rimraf");

/***/ }),
/* 30 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _webpack = __webpack_require__(2);

var _webpack2 = _interopRequireDefault(_webpack);

var _webpack3 = __webpack_require__(12);

var _webpack4 = _interopRequireDefault(_webpack3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var handleError = function handleError(err) {
  throw new Error(err);
};

exports.default = function (config) {
  return function () {
    return new Promise(function (resolve) {
      (0, _webpack2.default)((0, _webpack4.default)(config), function (err, stats) {
        if (err) handleError(err);
        resolve(stats);
      });
    });
  };
};

/***/ }),
/* 31 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (config) {
  return function (stats) {
    var outputStats = config.outputStats;

    if (outputStats) {
      console.log('trying to output', outputStats);
    }
    return new Promise(function (resolve) {
      return resolve(stats.hash);
    });
  };
};

/***/ })
/******/ ]);