'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (routes) {
  return routes.filter(function (route) {
    return typeof route.bundle !== 'undefined';
  }).reduce(function (acc, route) {
    acc[route.bundle.name.toLowerCase()] = route.bundle.location;
    return acc;
  }, {});
};