'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reduce = require('lodash/reduce');

var _reduce2 = _interopRequireDefault(_reduce);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getMetaData = function getMetaData(meta, urlParams) {
  return urlParams ? (0, _reduce2.default)(meta, function (acc, metaVal, metaKey) {
    var metaValStr = metaVal;
    var paramKeys = Object.keys(urlParams);
    var paramValues = Object.values(urlParams);

    paramKeys.forEach(function (key, i) {
      metaValStr = metaValStr.replace('{' + key + '}', paramValues[i]);
    });

    acc[metaKey] = metaValStr;
    return acc;
  }, {}) : meta;
};
exports.default = getMetaData;