import React, { Component } from 'react';

export default WrappedComponent => class HOC extends Component {
  constructor() {
    super();
    const scriptsEl = document.getElementById('app-props');
    const serverProps = scriptsEl ? scriptsEl.textContent : {};

    this.state = {
      serverProps: JSON.parse(
        //  eslint-disable-next-line
        serverProps.replace("<![CDATA[", "").replace("]]>", "")
      ),
    };
  }

  render() {
    const { serverProps } = this.state;
    return <WrappedComponent {...serverProps} />;
  }
};
