import { compose } from 'compose-middleware';

import compiler from './compiler';
import token from './token';
import universal from './universal';

const middleware = [compiler, token, universal];

export default (app, config) => compose(
  middleware.map(m => m(app, config)),
);
