//  @flow
import type { IRoute } from './../../../flow/IRoute';

export default (routes: Array<IRoute>) => (
  routes.filter(route => typeof route.bundle !== 'undefined')
    .reduce((acc, route) => {
      acc[route.bundle.name.toLowerCase()] = route.bundle.location;
      return acc;
    }, {})
);
