import { expect } from 'chai';

import getBundlesByName from './getBundlesByName';

describe('getBundlesByName', () => {
  it('should reduce route array array of names', () => {
    const routes = [
      {
        bundle: {
          name: 'foo',
          location: 'foo/fooContainer',
        },
      },
      {
        bundle: {
          name: 'bar',
          location: 'bar/barContainer',
        },
      },
    ];

    expect(getBundlesByName(routes)).to.eql(['foo', 'bar']);
  });
});
