#!/usr/bin/env node
module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 32);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("path");

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = __webpack_require__(0);

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  context: _path2.default.resolve(process.cwd(), './src'),
  distOutput: '/public',
  jsPath: 'js',
  cssPath: 'css',
  publicPath: '/assets/',
  indexFile: 'index.html',
  staticAssetsPath: '/public/assets',
  localIdentName: '[name]__[local]--[hash:base64:5]',
  autoPrefixer: ['last 2 versions'],
  devCssBundle: 'styles.bundle.css',
  prodCssBundle: 'styles.[contenthash:8].bundle.css',
  diagnostics: {
    heartbeat: '/diagnostic/heartbeat',
    version: '/diagnostic/version'
  },
  isDevEnvironment: process.env.NODE_ENV !== 'production'
};

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("webpack");

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = require("yargs");

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = require("extract-text-webpack-plugin");

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMessage = undefined;

var _yargs = __webpack_require__(3);

var _argv$debug = _yargs.argv.debug,
    debug = _argv$debug === undefined ? false : _argv$debug;


var messages = {
  welcome: function welcome(_ref) {
    var appName = _ref.appName,
        isDevEnvironment = _ref.isDevEnvironment,
        port = _ref.port;
    return '                  \n    RCA-Precursor: Starting ' + appName + '\n    http://localhost:' + (port || 3000) + '\n    Environment: ' + (isDevEnvironment ? 'Development' : 'Production') + '\n    Debug: ' + debug + '\n  ';
  },
  error: function error(_ref2) {
    var type = _ref2.type,
        _error = _ref2.error;

    var types = {
      static: 'StaticMiddleware:\n\n' + _error
    };
    return types[type];
  }
};

var getMessage = exports.getMessage = function getMessage(type, args) {
  return messages[type] ? messages[type](args) : messages.error;
};

exports.default = function (err) {
  return console.log(err);
};

/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = require("babel-polyfill");

/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = require("babel-register");

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _cssModulesRequireHook = __webpack_require__(9);

var _cssModulesRequireHook2 = _interopRequireDefault(_cssModulesRequireHook);

var _defaultConfig = __webpack_require__(1);

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _cssModulesRequireHook2.default)({
  generateScopedName: _defaultConfig2.default.localIdentName
});

/***/ }),
/* 9 */
/***/ (function(module, exports) {

module.exports = require("css-modules-require-hook");

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
//  Nasty.
//  eslint-disable-next-line
var evalImport = function evalImport(p) {
  return eval('require(\'' + p + '\');');
};

exports.default = function (filename) {
  return new Promise(function (resolve, reject) {
    var configFile = filename;
    if (!configFile.includes('.js')) {
      configFile += '.js';
    }
    try {
      resolve(evalImport(configFile).default);
    } catch (err) {
      reject(err);
    }
  });
};

/***/ }),
/* 11 */
/***/ (function(module, exports) {

module.exports = require("fs");

/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _path = __webpack_require__(0);

var _path2 = _interopRequireDefault(_path);

var _loaders = __webpack_require__(13);

var _loaders2 = _interopRequireDefault(_loaders);

var _plugins = __webpack_require__(16);

var _plugins2 = _interopRequireDefault(_plugins);

var _defaultConfig = __webpack_require__(1);

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (config) {
  var _config$context = config.context,
      context = _config$context === undefined ? _path2.default.resolve(process.cwd(), './src') : _config$context,
      entry = config.entry,
      _config$distOutput = config.distOutput,
      distOutput = _config$distOutput === undefined ? _defaultConfig2.default.distOutput : _config$distOutput,
      _config$publicPath = config.publicPath,
      publicPath = _config$publicPath === undefined ? _defaultConfig2.default.publicPath : _config$publicPath,
      _config$jsPath = config.jsPath,
      jsPath = _config$jsPath === undefined ? _defaultConfig2.default.jsPath : _config$jsPath,
      isDevEnvironment = config.isDevEnvironment;


  if (!entry) {
    throw new Error('No entry files are specified');
  }

  return _extends({
    context: context,

    entry: _extends({}, entry, isDevEnvironment && {
      hotReload: 'webpack-hot-middleware/client?reload=true'
    }),

    output: {
      filename: isDevEnvironment ? jsPath + '/[name].bundle.js' : jsPath + '/[name].[chunkhash:8].bundle.js',
      chunkFilename: isDevEnvironment ? jsPath + '/[name].chunk.js' : jsPath + '/[name].[chunkhash:8].chunk.js',
      path: _path2.default.join(process.cwd(), distOutput, publicPath),
      publicPath: publicPath
    }

  }, isDevEnvironment && {
    devServer: {
      contentBase: publicPath,
      hot: true,
      inline: true,
      historyApiFallback: true
    } && {
      devtool: 'cheap-module-source-map'
    }
  }, {

    module: {
      rules: (0, _loaders2.default)(config)
    },
    plugins: (0, _plugins2.default)(config)
  });
};

/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extractTextWebpackPlugin = __webpack_require__(4);

var _extractTextWebpackPlugin2 = _interopRequireDefault(_extractTextWebpackPlugin);

var _defaultConfig = __webpack_require__(1);

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

var _webpack = __webpack_require__(2);

var _webpack2 = _interopRequireDefault(_webpack);

var _postcssImport = __webpack_require__(14);

var _postcssImport2 = _interopRequireDefault(_postcssImport);

var _postcssCssnext = __webpack_require__(15);

var _postcssCssnext2 = _interopRequireDefault(_postcssCssnext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var _ref$localIdentName = _ref.localIdentName,
      localIdentName = _ref$localIdentName === undefined ? _defaultConfig2.default.localIdentName : _ref$localIdentName;
  return [{
    test: /\.js?$/,
    exclude: /node_modules/,
    loader: 'babel-loader',
    options: {
      babelrc: false,
      presets: ['es2015', 'react', 'stage-0'],
      plugins: ['transform-regenerator']
    }
  }, {
    test: /\.(css|scss)?$/,
    exclude: /node_modules/,
    loader: _extractTextWebpackPlugin2.default.extract([{
      loader: 'css-loader',
      options: {
        context: './',
        modules: true,
        importLoaders: 1,
        localIdentName: localIdentName
      }
    }, {
      loader: 'postcss-loader',
      options: {
        plugins: [(0, _postcssImport2.default)({
          addDependencyTo: _webpack2.default
        }), (0, _postcssCssnext2.default)()]
      }
    }])
  }, {
    test: /\.(png|svg)?$/,
    exclude: /node_modules/,
    use: {
      loader: 'file-loader',
      options: {
        name: '[name].[hash].[ext]',
        outputPath: '/images'
      }
    }
  }];
};

/***/ }),
/* 14 */
/***/ (function(module, exports) {

module.exports = require("postcss-import");

/***/ }),
/* 15 */
/***/ (function(module, exports) {

module.exports = require("postcss-cssnext");

/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _webpack = __webpack_require__(2);

var _webpack2 = _interopRequireDefault(_webpack);

var _path = __webpack_require__(0);

var _path2 = _interopRequireDefault(_path);

var _htmlWebpackPlugin = __webpack_require__(17);

var _htmlWebpackPlugin2 = _interopRequireDefault(_htmlWebpackPlugin);

var _extractTextWebpackPlugin = __webpack_require__(4);

var _extractTextWebpackPlugin2 = _interopRequireDefault(_extractTextWebpackPlugin);

var _chunkManifestWebpackPlugin = __webpack_require__(18);

var _chunkManifestWebpackPlugin2 = _interopRequireDefault(_chunkManifestWebpackPlugin);

var _webpackChunkHash = __webpack_require__(19);

var _webpackChunkHash2 = _interopRequireDefault(_webpackChunkHash);

var _uglifyjsWebpackPlugin = __webpack_require__(20);

var _uglifyjsWebpackPlugin2 = _interopRequireDefault(_uglifyjsWebpackPlugin);

var _bundling = __webpack_require__(21);

var _defaultConfig = __webpack_require__(1);

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var isVendor = function isVendor(_ref) {
  var resource = _ref.resource;
  return resource && resource.indexOf('node_modules') >= 0 && resource.match(/\.js$/);
};

exports.default = function (_ref2) {
  var _ref2$context = _ref2.context,
      context = _ref2$context === undefined ? _defaultConfig2.default.context : _ref2$context,
      _ref2$distOutput = _ref2.distOutput,
      distOutput = _ref2$distOutput === undefined ? _defaultConfig2.default.distOutput : _ref2$distOutput,
      _ref2$jsPath = _ref2.jsPath,
      jsPath = _ref2$jsPath === undefined ? _defaultConfig2.default.jsPath : _ref2$jsPath,
      _ref2$cssPath = _ref2.cssPath,
      cssPath = _ref2$cssPath === undefined ? _defaultConfig2.default.cssPath : _ref2$cssPath,
      _ref2$devCssBundle = _ref2.devCssBundle,
      devCssBundle = _ref2$devCssBundle === undefined ? _defaultConfig2.default.devCssBundle : _ref2$devCssBundle,
      _ref2$prodCssBundle = _ref2.prodCssBundle,
      prodCssBundle = _ref2$prodCssBundle === undefined ? _defaultConfig2.default.prodCssBundle : _ref2$prodCssBundle,
      isDevEnvironment = _ref2.isDevEnvironment,
      _ref2$plugins = _ref2.plugins,
      plugins = _ref2$plugins === undefined ? [] : _ref2$plugins,
      routes = _ref2.routes;

  //  Gets all { bundle } values from the routeConfig
  var bundleNames = (0, _bundling.getBundlesByName)(routes);

  //  Environment plugins define how webpack should
  //  be bundled for both production and development.
  //  Things like hot-module-reloading aren't required for
  //  prod, as an example.
  var environmentPlugins = !isDevEnvironment ? [new _webpack2.default.HashedModuleIdsPlugin(), new _webpackChunkHash2.default(), new _chunkManifestWebpackPlugin2.default({
    filename: jsPath + '/chunk-manifest.js',
    manifestVariable: 'webpackManifest',
    inlineManifest: true
  }), new _uglifyjsWebpackPlugin2.default()] : [new _webpack2.default.HotModuleReplacementPlugin()];

  return [].concat(_toConsumableArray(plugins), environmentPlugins, [

  //  Webpack bundle injection
  //  An array of chunks to be excluded from
  //  the HtmlWebpackPlugin injection.  This is important
  //  because routes that require lazy loading will be
  //  injected into the <head> when they are needed
  new _htmlWebpackPlugin2.default({
    inject: true,
    template: context + '/index.html',
    filename: _path2.default.join(process.cwd(), '.', distOutput, 'index.html'),
    excludeChunks: bundleNames
  }),

  //  Chunk common vendor / main files
  new _webpack2.default.optimize.CommonsChunkPlugin({
    name: ['vendor', 'manifest'],
    minChunks: isVendor
  })], _toConsumableArray(bundleNames.length && bundleNames.map(function (name) {
    return new _webpack2.default.optimize.CommonsChunkPlugin({
      name: name,
      chunks: [name],
      minChunks: 1
    });
  })), [new _extractTextWebpackPlugin2.default({
    filename: isDevEnvironment ? devCssBundle : cssPath + '/' + prodCssBundle,
    allChunks: true
  }),

  //  Output bundles will run in
  //  either production or development
  new _webpack2.default.DefinePlugin({
    'process.env': {
      NODE_ENV: JSON.stringify(isDevEnvironment ? 'development' : 'production'),
      API_URL: JSON.stringify('http://10.10.10.10:8080/bands')
    }
  })]);
};

/***/ }),
/* 17 */
/***/ (function(module, exports) {

module.exports = require("html-webpack-plugin");

/***/ }),
/* 18 */
/***/ (function(module, exports) {

module.exports = require("chunk-manifest-webpack-plugin");

/***/ }),
/* 19 */
/***/ (function(module, exports) {

module.exports = require("webpack-chunk-hash");

/***/ }),
/* 20 */
/***/ (function(module, exports) {

module.exports = require("uglifyjs-webpack-plugin");

/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getBundlesByName = exports.getBundleEntriesFromRoutes = undefined;

var _getBundleEntriesFromRoutes2 = __webpack_require__(22);

var _getBundleEntriesFromRoutes3 = _interopRequireDefault(_getBundleEntriesFromRoutes2);

var _getBundlesByName2 = __webpack_require__(23);

var _getBundlesByName3 = _interopRequireDefault(_getBundlesByName2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.getBundleEntriesFromRoutes = _getBundleEntriesFromRoutes3.default;
exports.getBundlesByName = _getBundlesByName3.default;

/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (routes) {
  return routes.filter(function (route) {
    return typeof route.bundle !== 'undefined';
  }).reduce(function (acc, route) {
    acc[route.bundle.name.toLowerCase()] = route.bundle.location;
    return acc;
  }, {});
};

/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (routes) {
  return routes.filter(function (route) {
    return typeof route.bundle !== 'undefined';
  }).map(function (route) {
    return route.bundle.name;
  });
};

/***/ }),
/* 24 */
/***/ (function(module, exports) {

module.exports = require("express");

/***/ }),
/* 25 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});


var hasInitialFetch = function hasInitialFetch(fn) {
  return typeof fn === 'function';
};


var fetchInitialProps = function fetchInitialProps(getInitialProps, routeParams) {
  return hasInitialFetch(getInitialProps) ? Promise.resolve(getInitialProps(routeParams)) : Promise.resolve(null);
};

exports.default = fetchInitialProps;

/***/ }),
/* 26 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var hasParam = function hasParam(str) {
  return str.indexOf(':') !== -1;
};

function getParamsFromUrl(routePath, urlPath) {
  if (!routePath) {
    return null;
  }

  return routePath.split('/').reduce(function (acc, part, i, arr) {
    if (hasParam(part)) {
      var key = arr[i].split(':').pop();
      acc[key] = urlPath.split('/')[i];
    }
    return acc;
  }, {});
}

exports.default = getParamsFromUrl;

/***/ }),
/* 27 */,
/* 28 */,
/* 29 */,
/* 30 */,
/* 31 */,
/* 32 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__(6);

__webpack_require__(7);

var _yargs = __webpack_require__(3);

var _path = __webpack_require__(0);

var _path2 = _interopRequireDefault(_path);

__webpack_require__(8);

var _requireFile = __webpack_require__(10);

var _requireFile2 = _interopRequireDefault(_requireFile);

var _server = __webpack_require__(33);

var _server2 = _interopRequireDefault(_server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
  var defaultConfigPath, _argv$config, config, userConfig, server;

  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          defaultConfigPath = './src/config';
          _argv$config = _yargs.argv.config, config = _argv$config === undefined ? defaultConfigPath : _argv$config;
          _context.next = 4;
          return (0, _requireFile2.default)(_path2.default.join(process.cwd(), config));

        case 4:
          userConfig = _context.sent;
          server = new _server2.default(userConfig);

          server.create();

        case 7:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, undefined);
}))();

/***/ }),
/* 33 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _express = __webpack_require__(24);

var _express2 = _interopRequireDefault(_express);

var _messaging = __webpack_require__(5);

var _staticHandler = __webpack_require__(34);

var _staticHandler2 = _interopRequireDefault(_staticHandler);

var _errorHandler = __webpack_require__(37);

var _errorHandler2 = _interopRequireDefault(_errorHandler);

var _middleware = __webpack_require__(38);

var _middleware2 = _interopRequireDefault(_middleware);

var _defaultConfig = __webpack_require__(1);

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Server = function () {
  function Server(config) {
    _classCallCheck(this, Server);

    this.config = _extends({}, _defaultConfig2.default, config);
    this.app = (0, _staticHandler2.default)((0, _express2.default)(), this.config);
  }

  _createClass(Server, [{
    key: 'create',
    value: function create(callback) {
      var app = this.app;
      var config = this.config;
      var port = config.port,
          diagnostics = config.diagnostics;


      app.get(diagnostics.heartbeat, function (req, res) {
        return res.send('OK');
      });

      app.get(diagnostics.version, function (req, res) {
        return res.send(process.env.APP_VERSION || '0.0.0');
      });

      app.use((0, _middleware2.default)(app, config), function (req, res) {
        return res.send(app.locals.output);
      });

      app.use(_errorHandler2.default);

      app.listen(port || 3000, function () {
        console.log((0, _messaging.getMessage)('welcome', config));
        if (callback && typeof callback === 'function') {
          callback();
        }
      });

      return app;
    }
  }]);

  return Server;
}();

exports.default = Server;

/***/ }),
/* 34 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = __webpack_require__(0);

var _path2 = _interopRequireDefault(_path);

var _express = __webpack_require__(24);

var _express2 = _interopRequireDefault(_express);

var _webpackDevMiddleware = __webpack_require__(35);

var _webpackDevMiddleware2 = _interopRequireDefault(_webpackDevMiddleware);

var _webpackHotMiddleware = __webpack_require__(36);

var _webpackHotMiddleware2 = _interopRequireDefault(_webpackHotMiddleware);

var _webpack = __webpack_require__(2);

var _webpack2 = _interopRequireDefault(_webpack);

var _messaging = __webpack_require__(5);

var _webpack3 = __webpack_require__(12);

var _webpack4 = _interopRequireDefault(_webpack3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (app, config) {
  var isDevEnvironment = config.isDevEnvironment,
      publicPath = config.publicPath,
      distOutput = config.distOutput,
      devCssBundle = config.devCssBundle;


  try {
    if (!isDevEnvironment) {
      app.use(publicPath, _express2.default.static(_path2.default.join(process.cwd(), distOutput, publicPath)));
    }

    if (isDevEnvironment) {
      //  eslint-disable-next-line
      app.locals.compiler = (0, _webpack2.default)((0, _webpack4.default)(config));

      //  eslint-disable-next-line
      app.locals.hotMiddleware = (0, _webpackHotMiddleware2.default)(app.locals.compiler);

      app.locals.compiler.plugin('done', function () {
        var extractedCSS = _path2.default.join(process.cwd(), distOutput, publicPath, devCssBundle);
        app.locals.compiler.outputFileSystem.readFile(extractedCSS, function (err, data) {
          if (!err) {
            app.locals.hotMiddleware.publish({ type: 'css-update', value: data.toString() });
          }
        });
      });

      app.use(publicPath, (0, _webpackDevMiddleware2.default)(app.locals.compiler));
      app.use(app.locals.hotMiddleware);
    }
  } catch (error) {
    throw new Error((0, _messaging.getMessage)('error', { type: 'static', error: error }));
  }

  return app;
};

/***/ }),
/* 35 */
/***/ (function(module, exports) {

module.exports = require("webpack-dev-middleware");

/***/ }),
/* 36 */
/***/ (function(module, exports) {

module.exports = require("webpack-hot-middleware");

/***/ }),
/* 37 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (err, req, res, next) {
  console.log(err.stack);
  next(err);
};

/***/ }),
/* 38 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _composeMiddleware = __webpack_require__(39);

var _compiler = __webpack_require__(40);

var _compiler2 = _interopRequireDefault(_compiler);

var _token = __webpack_require__(41);

var _token2 = _interopRequireDefault(_token);

var _universal = __webpack_require__(42);

var _universal2 = _interopRequireDefault(_universal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var middleware = [_compiler2.default, _token2.default, _universal2.default];

exports.default = function (app, config) {
  return (0, _composeMiddleware.compose)(middleware.map(function (m) {
    return m(app, config);
  }));
};

/***/ }),
/* 39 */
/***/ (function(module, exports) {

module.exports = require("compose-middleware");

/***/ }),
/* 40 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fs = __webpack_require__(11);

var _fs2 = _interopRequireDefault(_fs);

var _path = __webpack_require__(0);

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var resolveHtml = function resolveHtml(fileLoader, indexPath) {
  return new Promise(function (resolve, reject) {
    return fileLoader.readFile(indexPath, function (err, fileContents) {
      var templateString = void 0;
      try {
        templateString = fileContents.toString();
      } catch (error) {
        reject('Compilation in progress... Hold tight!');
      } finally {
        resolve(templateString);
      }
    });
  });
};

exports.default = function (app, config) {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res, next) {
      var isDevEnvironment, distOutput, indexFile, indexPath, fileLoader;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(app.locals && app.locals.html)) {
                _context.next = 4;
                break;
              }

              next();
              _context.next = 11;
              break;

            case 4:
              isDevEnvironment = config.isDevEnvironment, distOutput = config.distOutput, indexFile = config.indexFile;
              indexPath = _path2.default.join(process.cwd(), distOutput, indexFile);
              fileLoader = isDevEnvironment ? app.locals.compiler.outputFileSystem : _fs2.default;

              //  eslint-disable-next-line

              _context.next = 9;
              return resolveHtml(fileLoader, indexPath);

            case 9:
              app.locals.html = _context.sent;

              next();

            case 11:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function (_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }();
};

/***/ }),
/* 41 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (app, config) {
  return function (req, res, next) {
    var _app = app;
    var environmentVariables = config.environmentVariables;


    if (_app.locals.isTokenized) {
      next();
    } else {
      if (environmentVariables) {
        Object.keys(environmentVariables).forEach(function (key) {
          _app.locals.html = _app.locals.html.replace('\xA1' + key + '!', environmentVariables[key]);
        });
      }
      _app.locals.isTokenized = true;
      next();
    }
  };
};

/***/ }),
/* 42 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

__webpack_require__(43);

var _react = __webpack_require__(44);

var _react2 = _interopRequireDefault(_react);

var _reactRouter = __webpack_require__(45);

var _server = __webpack_require__(46);

var _utils = __webpack_require__(47);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = function (app, config) {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res, next) {
      var _app, tmpl, serverProps, Root, routes, _matchRoute, meta, path, component, urlParams, metaData;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _app = app;
              tmpl = app.locals.html;

              //  The props we'll inject into the root component

              serverProps = {};

              //  Grab the things we need from the userConfig

              Root = config.root, routes = config.routes;

              //  Resolve the current route from the supplied
              //  array of SPA routes.

              _matchRoute = (0, _utils.matchRoute)(routes, req.url), meta = _matchRoute.meta, path = _matchRoute.path, component = _matchRoute.component;

              //  TODO handle 404's and broken promises

              if (!path) {
                res.status(404);
              }

              //  Fetch any initialProps to populate route data
              urlParams = (0, _utils.getParamsFromUrl)(path, req.url);
              _context.next = 9;
              return (0, _utils.fetchInitialProps)(component.getInitialProps, urlParams);

            case 9:
              serverProps[req.url] = _context.sent;


              //  Get the contextRoute meta data and
              //  populate the html server-side
              metaData = (0, _utils.getMetaData)(meta, urlParams);

              Object.keys(metaData).forEach(function (key) {
                tmpl = tmpl.replace('{meta.' + key + '}', metaData[key]);
              });

              //  Replaces the <div id="root" /> element
              //  with the server rendered application
              _app.locals.output = tmpl.replace('<div id="root" />', '<div id="root">\n      ' + (0, _utils.getRootString)((0, _server.renderToString)(_react2.default.createElement(
                _reactRouter.StaticRouter,
                { location: req.url, context: {} },
                _react2.default.createElement(Root, serverProps)
              )), serverProps) + '\n    </div>');

              next();

            case 14:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function (_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }();
};

/***/ }),
/* 43 */
/***/ (function(module, exports) {

module.exports = require("require-ensure");

/***/ }),
/* 44 */
/***/ (function(module, exports) {

module.exports = require("react");

/***/ }),
/* 45 */
/***/ (function(module, exports) {

module.exports = require("react-router");

/***/ }),
/* 46 */
/***/ (function(module, exports) {

module.exports = require("react-dom/server");

/***/ }),
/* 47 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resolveInitialProps = exports.getRouteComponent = exports.requiresPrefetch = exports.matchRoute = exports.getRootString = exports.getParamsFromUrl = exports.getMetaData = exports.fetchInitialProps = undefined;

var _fetchInitialProps2 = __webpack_require__(25);

var _fetchInitialProps3 = _interopRequireDefault(_fetchInitialProps2);

var _getMetaData2 = __webpack_require__(48);

var _getMetaData3 = _interopRequireDefault(_getMetaData2);

var _getParamsFromUrl2 = __webpack_require__(26);

var _getParamsFromUrl3 = _interopRequireDefault(_getParamsFromUrl2);

var _getRootString2 = __webpack_require__(50);

var _getRootString3 = _interopRequireDefault(_getRootString2);

var _matchRoute2 = __webpack_require__(51);

var _matchRoute3 = _interopRequireDefault(_matchRoute2);

var _requiresPrefetch2 = __webpack_require__(52);

var _requiresPrefetch3 = _interopRequireDefault(_requiresPrefetch2);

var _getRouteComponent2 = __webpack_require__(53);

var _getRouteComponent3 = _interopRequireDefault(_getRouteComponent2);

var _resolveInitialProps2 = __webpack_require__(54);

var _resolveInitialProps3 = _interopRequireDefault(_resolveInitialProps2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.fetchInitialProps = _fetchInitialProps3.default;
exports.getMetaData = _getMetaData3.default;
exports.getParamsFromUrl = _getParamsFromUrl3.default;
exports.getRootString = _getRootString3.default;
exports.matchRoute = _matchRoute3.default;
exports.requiresPrefetch = _requiresPrefetch3.default;
exports.getRouteComponent = _getRouteComponent3.default;
exports.resolveInitialProps = _resolveInitialProps3.default;

/***/ }),
/* 48 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reduce = __webpack_require__(49);

var _reduce2 = _interopRequireDefault(_reduce);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getMetaData = function getMetaData(meta, urlParams) {
  return urlParams ? (0, _reduce2.default)(meta, function (acc, metaVal, metaKey) {
    var metaValStr = metaVal;
    var paramKeys = Object.keys(urlParams);
    var paramValues = Object.values(urlParams);

    paramKeys.forEach(function (key, i) {
      metaValStr = metaValStr.replace('{' + key + '}', paramValues[i]);
    });

    acc[metaKey] = metaValStr;
    return acc;
  }, {}) : meta;
};
exports.default = getMetaData;

/***/ }),
/* 49 */
/***/ (function(module, exports) {

module.exports = require("lodash/reduce");

/***/ }),
/* 50 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (root, props) {
  return "<script id='app-props' type='application/json'><![CDATA[" + JSON.stringify(props) + "]]></script><div id=\"root\">" + root + "</div>";
};

/***/ }),
/* 51 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (routes, url) {
  var foundRoute = routes.filter(function (_ref) {
    var path = _ref.path;

    if (!path) {
      return null;
    }

    //  Check for any exact matches
    if (path === url) {
      return path;
    }

    //  Check for dynamic routes
    //  with the ':' as params
    var urlParts = url.split('/');
    var dynamicPath = path.split('/').map(function (part, index) {
      return part.includes(':') && path.replace(part, urlParts[index]);
    }).filter(Boolean)[0];
    return dynamicPath === url;
  });

  if (foundRoute.length === 0) {
    foundRoute = routes.filter(function (route) {
      return route.path === null;
    });
  }

  return foundRoute.length ? foundRoute[0] : null;
};

/***/ }),
/* 52 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (component) {
  return typeof component.getInitialProps === 'function';
};

/***/ }),
/* 53 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
// import path from 'path';

// export default (config, contextRoute) => {
//   const { context = path.resolve(process.cwd(), './src') } = config;
//   const { bundle, component } = contextRoute;

//   if (typeof bundle !== 'undefined') {
//     const componentPath = path.resolve(process.cwd(), `${context}/${bundle.location}.js`);
//     return require(componentPath).default;
//   }
//   return component;
// };


/***/ }),
/* 54 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getParamsFromUrl = __webpack_require__(26);

var _getParamsFromUrl2 = _interopRequireDefault(_getParamsFromUrl);

var _fetchInitialProps = __webpack_require__(25);

var _fetchInitialProps2 = _interopRequireDefault(_fetchInitialProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var hasInitialProps = function hasInitialProps(component) {
  return component.getInitialProps && typeof component.getInitialProps === 'function';
};

exports.default = function (component, path, pathname) {
  if (hasInitialProps(component)) {
    var urlParams = (0, _getParamsFromUrl2.default)(path, pathname);
    return (0, _fetchInitialProps2.default)(component.getInitialProps, urlParams);
  }
  return null;
};

/***/ })
/******/ ]);