'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var renderRoute = function renderRoute(component) {
  var _class, _temp;

  return _temp = _class = function (_Component) {
    _inherits(HOC, _Component);

    function HOC(props, context) {
      _classCallCheck(this, HOC);

      var _this = _possibleConstructorReturn(this, (HOC.__proto__ || Object.getPrototypeOf(HOC)).call(this, props));

      var pathname = props.location.pathname;

      _this.state = {
        async: (0, _utils.requiresPrefetch)(component),
        data: context.getRouteData(pathname)
      };
      return _this;
    }

    _createClass(HOC, [{
      key: 'render',
      value: function render() {
        var WrappedComponent = component;
        var _state = this.state,
            async = _state.async,
            data = _state.data;


        if (async && !data) {
          return null;
        }
        return _react2.default.createElement(WrappedComponent, { data: data });
      }
    }]);

    return HOC;
  }(_react.Component), _class.contextTypes = {
    getRouteData: _propTypes2.default.func.isRequired
  }, _temp;
};

exports.default = renderRoute;