'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});


var hasInitialFetch = function hasInitialFetch(fn) {
  return typeof fn === 'function';
};


var fetchInitialProps = function fetchInitialProps(getInitialProps, routeParams) {
  return hasInitialFetch(getInitialProps) ? Promise.resolve(getInitialProps(routeParams)) : Promise.resolve(null);
};

exports.default = fetchInitialProps;