'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var hasParam = function hasParam(str) {
  return str.indexOf(':') !== -1;
};

function getParamsFromUrl(routePath, urlPath) {
  if (!routePath) {
    return null;
  }

  return routePath.split('/').reduce(function (acc, part, i, arr) {
    if (hasParam(part)) {
      var key = arr[i].split(':').pop();
      acc[key] = urlPath.split('/')[i];
    }
    return acc;
  }, {});
}

exports.default = getParamsFromUrl;